// Purpose:	Assert
// Author : ڱ
// Update : 2003/04/21
// Date	  : 2003/04/18

#if defined(_DEBUG)

//
// Headers
//

#include <assert.h>
#include <pesc.h>

//
// Definitions
//

LPCSTR      C_Assert::mc_lpszAssertFile = "ASSERT.TXT";
FILE*       C_Assert::ms_pflAssert = NULL;
C_Assert    g_Assert;

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

// Purpose:	Assert  Trace ϱ  ʱȭ Ѵ. 
C_Assert::C_Assert()
{
    //  νϽ ϱ  assert Ͽ.
    assert(!ms_pflAssert);

    ms_pflAssert = fopen(mc_lpszAssertFile, "w");
}

// Purpose:	 ü ҸŲ. 
C_Assert::~C_Assert()
{
	if (!ms_pflAssert)
 		fclose(ms_pflAssert);
}

//////////////////////////////////////////////////////////////////////
// Methods
//////////////////////////////////////////////////////////////////////

// Purpose:	Trace Ѵ.
// Accepts:	c_lpszFile- ϸ, iLine- Trace, c_lpszFunc- Լ
//          c_lpszFormat- printf parameters
void C_Assert::Trace(LPCSTR c_lpszFile, int iLine, LPCSTR c_lpszFunc,
    LPCSTR c_lpszFormat, ...)
{
    assert(c_lpszFile);
    assert(*c_lpszFile);
    assert(c_lpszFunc);
    assert(*c_lpszFunc);
    assert(c_lpszFormat);
    assert(*c_lpszFormat);

	if (ms_pflAssert)
	{
		va_list	ap;
        string strTime = GetCurrentTm();

  		fprintf(ms_pflAssert,"[%s] %s::%s(%d) ", strTime.c_str(),
            PescGetFileExceptPath(c_lpszFile), c_lpszFunc, iLine);

		va_start(ap, c_lpszFormat);
		vfprintf(ms_pflAssert, c_lpszFormat, ap);
		va_end(ap);

		fprintf(ms_pflAssert,"\n");
		fflush(ms_pflAssert);
	}
}

// Purpose:	Assert Ѵ.
// Accepts:	c_lpszFile- ϸ, iLine- Assert 
void C_Assert::Assert(LPCSTR c_lpszFile, int iLine, LPCSTR c_lpszText)
{
    assert(c_lpszFile);
    assert(*c_lpszFile);
    assert(c_lpszText);
    assert(*c_lpszText);

	if (ms_pflAssert)
	{
        string strTime = GetCurrentTm();
		fprintf(ms_pflAssert,"[%s] %s(%d) Assertion Failed! %s\n"
  			, strTime.c_str(), PescGetFileExceptPath(c_lpszFile), iLine, c_lpszText);
	}

	exit(-1);
}

// Purpose: ð  Ʈ ȯѴ.
// Returns: ð  Ʈ 
string C_Assert::GetCurrentTm()
{
    C_Time  Time = C_Time::GetCurrentTm();
    return  Time.Format("%y-%m-%d %H:%M:%S");
}

#endif  // _DEBUG
